% 21 mW/cm2 
clear all
close all
clc

%% Measurements
load ('1LED_3.9V_4.2A_2steps2.mat')

%%
%%make the normalized array
normarray=meandata;
%% plot the circle and area of interest
%define range
x_start = 4;
x_end = 53;
y_start = 6;
y_end = 55;
pix2mm=0.5; %the scaling between pixels and mm: one pixel is 0.5x0.5 mm^2
totalirradiation=66/1000 % [W] mW 15 for 5, 31 for 10 and 66 for 21
diameter=2/100; %[m] it is 20 mm the optical window diameter
area= pi*(diameter/2)^2; %[m2]
power=totalirradiation/area %to get W/m2 

totalpixel=sum(sum(meandata)); %all the values in the circle
irradiation= meandata*totalirradiation/totalpixel/((pix2mm/1000)^2);% to calculate W.m^-2 because 1 pixel is 0.5 mm

circlevar = irradiation(x_start:x_end,y_start:y_end);%to plot the area we want to see
sum(sum(irradiation))*((pix2mm/1000)^2)%to check it is okay, should be equal to totalirradiation
%plot data
figure;
%subplot(1,2,2)
X = 0:1:length(circlevar)-1;
X = X*pix2mm
Y=X;
handle=pcolor(X,Y,circlevar);
set(handle,'LineStyle','none'); %to remove the squares in the plot
hcb=colorbar;

% map = [0.2 0.2 0.2
%     0.2 0 0.2
%     0.3 0 0.3
%     0.4 0 0.4
%     .5 0 .5];
% colormap(map)

% map=gray.*[.8 0 1];
map=gray.*[.56 0.58 1];
colormap(map)
%For article Font 16 and 18 title, for GA 24 and 26
set(hcb, 'FontSize', 24);
set(get(hcb,'label'),'string','Irradiation [W.m^{-2}]');%,'FontSize', 18);
hx=xlabel('Position [mm]');
set(hx, 'FontSize', 24);
hy=ylabel('Position [mm]');
set(hy, 'FontSize', 24);
axis equal;
xlim([1 24])
caxis([1 630])

%title('15 mW <> 5 mW.cm^{-2}','FontSize', 20);%15 for 5, 31 for 10 and 66 for 21
%title('31 mW <> 10 mW.cm^{-2}','FontSize', 20);
%title('Mono-LED 66 mW <> 210 W.m^{-2}','FontSize', 26);
 title('Mono-LED 210 W.m^{-2}','FontSize', 26);
% plot circle
x_center = (0.5*(x_end-x_start))*pix2mm; %multiply by 0.5 because the center is the diameter/2, +1 in included because the plot starts at 1,1 instead of 0,0 so we need to compensate for that.
y_center = (0.5*(y_end-y_start))*pix2mm;
% define circle
theta = [0:0.001:2*pi];
radius = 20*pix2mm;
% determine x and y position of circle
x = radius * cos(theta) + x_center; %to plot the cirlce with the mcenter being the middle of the image
y = radius * sin(theta) + y_center;
% plot the circle
hold on
plot(x,y,'w.','Markersize',10)
% axis equal

%% create a circular mask matrix
x = -0.5*(x_end-x_start)+0.5:0.5*(x_end-x_start)+0.5; %define x and y coordinate. Shu: It has +0.5 because the plot is not starting from 0,0.
y = -0.5*(y_end-y_start)+0.5:0.5*(y_end-y_start)+0.5;
% x = -x_center:x_center;
% y = -y_center:y_center;
[xx yy] = meshgrid(x,y); % create 2d grid coordinates
mask = zeros(size(xx)); %create the mask of right size, filled with zeros

mask_radius = radius/pix2mm; %define radius of the masking circle. Shu: this is for meandata in pixels and the radius before was for the data in mm
mask((xx.^2+yy.^2)<mask_radius^2)=1; %all values within the circle become one
mask = logical(mask); %tell matlab it is a mask
inv_mask = ~mask; %make an inverted mask

%% calculate mean of the masked value
mean_value = mean(circlevar(mask))
min_value =min(circlevar(mask))
max_value =max(circlevar(mask))
std_value=std(circlevar(mask))
%% this is not good to compared with Casados or Martin because here circlevar is already normalized
homogeneity= std_value/mean_value*100
uniformity=1-((sum(abs(circlevar(mask)-mean_value)))/(2*mean_value*numel(circlevar(mask))))
uniformity2=1-((sum(abs(circlevar(mask)-mean_value)))/(2*(sum(abs(circlevar(mask))))))

