clear all
close all
clc

%% Measurements
load ('12LED_15.1V_1.24A_2steps.mat')
%load ('12LED_14.5V_0.94A_2steps.mat')
%%
%%make the normalized array
normarray=meandata;
%% plot the circle and area of interest
% define range
x_start = 2;
x_end = 51;
y_start = 7;
y_end = 56;
% x_start = 2;
% x_end = 51;
% y_start = 10;
% y_end = 59;
diameter=2; %[cm] it is 20 mm the optical window diameter
area= pi*(diameter/2)^2;
totalirradiation=55*area; %[mW] 55 mW/cm2* area
totalpixel=sum(sum(meandata)); %all the values in the circle
irradiation= meandata*totalirradiation/totalpixel;

circlevar = irradiation(x_start:x_end,y_start:y_end);
sum(sum(irradiation))%to check it is okay
%plot data
figure;
%subplot(1,2,2)
handle=pcolor(circlevar);
set(handle,'LineStyle','none'); %to remove the squares in the plot
hcb=colorbar;
%colormap jet;
set(hcb, 'FontSize', 18);
set(get(hcb,'label'),'string','Irradiation [mW]');%,'FontSize', 18);
hx=xlabel('Position [mm]');
set(hx, 'FontSize', 18);
hy=ylabel('Position [mm]');
set(hy, 'FontSize', 18);
axis equal;
xlim([1 49])
% title('5 mW/cm^{2}');
title('55 mW/cm^{2} <> 173 mW','FontSize', 20);

% plot circle
x_center = 0.5*(x_end-x_start)+1; %multiply by 0.5 because the center is the diameter/2, +1 in included because the plot starts at 1,1 instead of 0,0 so we need to compensate for that.
y_center = 0.5*(y_end-y_start)+1;
% define circle
theta = [0:0.001:2*pi];
radius = 20;
% determine x and y position of circle
x = radius * cos(theta) + x_center; %to plot the cirlce with the mcenter being the middle of the image
y = radius * sin(theta) + y_center;
% plot the circle
hold on
plot(x,y,'k.','Markersize',10)
% axis equal

%% create a circular mask matrix
x = -0.5*(x_end-x_start)+0.5:0.5*(x_end-x_start)+0.5; %define x and y coordinate. Shu: It has +0.5 because the plot is not starting from 0,0.
y =  -0.5*(y_end-y_start)+0.5:0.5*(y_end-y_start)+0.5; 
[xx yy] = meshgrid(x,y); % create 2d grid coordinates
mask = zeros(size(xx)); %create the mask of right size, filled with zeros

mask_radius = radius; %define radius of the masking circle
mask((xx.^2+yy.^2)<mask_radius^2)=1; %all values within the circle become one
mask = logical(mask); %tell matlab it is a mask
inv_mask = ~mask; %make an inverted mask

%% calculate mean of the masked value
mean_value = mean(circlevar(mask))
min_value =min(circlevar(mask))
max_value =max(circlevar(mask))
std_value=std(circlevar(mask))
%% this is not good to compared with Casados or Martin because here circlevar is already normalized
homogeneity= std_value/mean_value*100
uniformity=1-((sum(abs(circlevar(mask)-mean_value)))/(2*mean_value*numel(circlevar(mask))))
uniformity2=1-((sum(abs(circlevar(mask)-mean_value)))/(2*(sum(abs(circlevar(mask))))))